unit DemoThreadClass;

interface

uses
  Classes, SysUtils;

type
  TFirstDemoThread = class(TThread)
  private
    { Private declarations }
  protected
    procedure Execute; override;
  public
    constructor Create;
  end;

type
  TPrimeAdder = class(TThread)
  private
    FMax: Integer;
    FInit: Integer;
  protected
    procedure Execute; override;
  public
    property Max: Integer read FMax write FMax;
    property Init: Integer read FInit write FInit;
  end;

function IsPrime (N: Integer): Boolean;

implementation

uses
  Windows, FirstThreadDemo_MainForm;

function IsPrime (N: Integer): Boolean;
var
  Test: Integer;
begin
  IsPrime := True;
  for Test := 2 to N - 1 do
    if (N mod Test) = 0 then
    begin
      IsPrime := False;
      break; {jump out of the for loop}
    end;
end;

constructor TFirstDemoThread.Create;
begin
  inherited Create (True);
  FreeOnTerminate := True;
  // "start" here won't work in Delphi 2010
  // Start;
  // up to Delphi 2009 was:
  // Resume;
end;

procedure TFirstDemoThread.Execute;
var
  nCount: Integer;
  I: Integer;
  nTicks: Cardinal;
begin
  nCount := 0;
  nTicks := GetTickCount;
  for I := 1 to 99999 do
    if IsPrime (I) then
      Inc (nCount);
  nTicks := GetTickCount - nTicks;
  Synchronize(
    procedure ()
    begin
      FormThreads.Memo1.Lines.Add('Thr - Count: ' + IntToStr (nCount));
      FormThreads.Memo1.Lines.Add('Thr - Ticks: ' + IntToStr (nTicks));
    end
  );
end;

procedure TPrimeAdder.Execute;
var
  I, nCount: Integer;
  nTicks: Cardinal;
begin
  nCount := 0;
  nTicks := GetTickCount;
  for I := FInit to FMax do
  begin
    if IsPrime (I) then
      Inc (nCount);
  end;
  nTicks := GetTickCount - nTicks;
  Synchronize(
    procedure ()
    begin
      FormThreads.Memo1.Lines.Add('Par - Count: ' + IntToStr (nCount));
      FormThreads.Memo1.Lines.Add('Par - Ticks: ' + IntToStr (nTicks));
    end
  );
end;

end.
