unit FirstThreadDemo_MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TFormThreads = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormThreads: TFormThreads;

implementation

{$R *.dfm}

uses
  DemoThreadClass;

procedure TFormThreads.Button1Click(Sender: TObject);
var
  nCount: Integer;
  I: Integer;
  nTicks: Cardinal;
begin
  nCount := 0;
  nTicks := GetTickCount;
  for I := 1 to 99999 do
    if IsPrime (I) then
      Inc (nCount);
  nTicks := GetTickCount - nTicks;
  Memo1.Lines.Add('Std - Count: ' + IntToStr (nCount));
  Memo1.Lines.Add('Std - Ticks: ' + IntToStr (nTicks));
end;

procedure TFormThreads.Button2Click(Sender: TObject);
var
  firstTh: TFirstDemoThread;
begin
  firstTh := TFirstDemoThread.Create;
  firstTh.Start; // Delphi 2010
end;

procedure TFormThreads.Button3Click(Sender: TObject);
var
  nCount: Integer;
  I: Integer;
  nTicks: Cardinal;
begin
  nCount := 0;
  nTicks := GetTickCount;
  for I := 1 to 99999 do
  begin
    if IsPrime (I) then
      Inc (nCount);
      Application.ProcessMessages;
  end;
  nTicks := GetTickCount - nTicks;
  Memo1.Lines.Add('Pro - Count: ' + IntToStr (nCount));
  Memo1.Lines.Add('Pro - Ticks: ' + IntToStr (nTicks));
end;

procedure TFormThreads.Button4Click(Sender: TObject);
var
  AdderThread1: TPrimeAdder;
  AdderThread2: TPrimeAdder;
  Max: Integer;
begin
  max := 99999;

  AdderThread1 := TPrimeAdder.Create (True);
  AdderThread1.Init := 1;
  AdderThread1.Max := Max div 7 * 5;
  AdderThread1.FreeOnTerminate := True;
  AdderThread1.Start; // was Resume

  AdderThread2 := TPrimeAdder.Create (True);
  AdderThread2.Init := Max div 7 * 5 + 1;
  AdderThread2.Max := Max;
  AdderThread2.FreeOnTerminate := True;
  AdderThread2.Start; // was Resume
end;

end.
